from distutils.core import setup, Extension
import shutil,os,sys,os.path
from stat import *
#from Pyrex.Distutils import build_ext

# Check for an old version of cgtypes
exitflag = 0
for mp in sys.path:
    if mp==os.getcwd():
        continue
    p = os.path.join(mp,"cgtypes")
    if os.path.isdir(p):
        print "There is an old version of cgkit installed."
        print "Please uninstall the old version or simply remove the following directory:"
        print p
        print "(otherwise the new cgtypes module won't be in effect)"
        exitflag=1
        break

if exitflag:
    sys.exit(1)

######################################################################

pyrex_in  = "cgtypes.pyx"
pyrex_out = "cgtypes.c"
pyrex_cmd = "pyrexc "+pyrex_in

# Check if the pyrex output is still up to date or if it has to be generated
if os.access(pyrex_out, os.F_OK):
    pytime = os.stat(pyrex_in)[ST_MTIME]
    ctime  = os.stat(pyrex_out)[ST_MTIME]
    if pytime>ctime:
        print "Updating",pyrex_out
        os.system(pyrex_cmd)
    else:
        print pyrex_out,"is up to date"
else:
    print "Creating",pyrex_out
    os.system(pyrex_cmd)

setup(name="cgkit",
      version="1.0beta3",
      description="Python Computer Graphics Kit",
      author="Matthias Baas",
      author_email="baas@ira.uka.de",
      url="http://cgkit.sourceforge.net",
      licence="BSD license, see license.txt",
      py_modules=["ri","riutil",
                  "pycgtypes.vec3","pycgtypes.mat3",
                  "pycgtypes.vec4","pycgtypes.mat4","pycgtypes.quat",
                  "sltokenize","sl"],
      ext_modules=[Extension("cgtypes", ["cgtypes.c"]),
                   Extension("noise", ["src/noisemodule.cpp"])
                   ]
      )
